//+------------------------------------------------------------------+
//|                                                  Fibo tenkan.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Vadim Shumiloff"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 Red

//---- input parameters
extern int Tenkan=24;
extern int smzper=9;
extern int smzmethod=1;

//---- buffers
double Tenkan_Buffer[];
double Tenkan_Buffer1[];
double Tenkan_Buffer38[];
double Tenkan_Buffer62[];

//----
int a_begin;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
   IndicatorBuffers(4); 


   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Tenkan_Buffer);
   SetIndexDrawBegin(0,Tenkan-1);
   SetIndexLabel(0,"Tenkan Sen");

   SetIndexBuffer(1,Tenkan_Buffer38);
   SetIndexDrawBegin(3,Tenkan-1);
   SetIndexLabel(1,"Tenkan Sen 38");
   SetIndexStyle(1,DRAW_LINE,STYLE_DOT);

   SetIndexBuffer(2,Tenkan_Buffer62);
   SetIndexDrawBegin(2,Tenkan-1);
   SetIndexLabel(2,"Tenkan Sen 62");
   SetIndexStyle(2,DRAW_LINE,STYLE_DOT);

   SetIndexBuffer(3,Tenkan_Buffer1);
   SetIndexDrawBegin(3,Tenkan+smzper);

   return(0);
  }

int start()
  {
   int    i,k;
   int    counted_bars=IndicatorCounted();
   double high,low,price;

   if(Bars<=Tenkan) return(0);

   if(counted_bars<1)
     {
      for(i=1;i<=Tenkan;i++)    
      {
         Tenkan_Buffer[Bars-i]=0;
         Tenkan_Buffer38[Bars-i]=0;
         Tenkan_Buffer62[Bars-i]=0;
      }
     }

   i=Bars-Tenkan;
   if(counted_bars>Tenkan) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+Tenkan;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      Tenkan_Buffer1[i]=(high+low)/2;
      i--;
     }
   
   for(i = Bars-counted_bars-smzper-1; i >= 0; i--)
      {
      Tenkan_Buffer[i] = Tenkan_Buffer1[i]+  Tenkan_Buffer1[i]-iMAOnArray(Tenkan_Buffer1,0,smzper,0,smzmethod, i);
Tenkan_Buffer38[i]= Tenkan_Buffer[i]-(high-low)*0.118;
Tenkan_Buffer62[i]= Tenkan_Buffer[i]+(high-low)*0.118;
}
 
   return(0);
  }
//+------------------------------------------------------------------+